diff --git a/src/main/java/net/minecraft/core/item/ItemJar.java b/src/main/java/net/minecraft/core/item/JarItem.java
similarity index 59%
rename from src/main/java/net/minecraft/core/item/ItemJar.java
rename to src/main/java/net/minecraft/core/item/JarItem.java
index 2bafe100a..55eb7b9fc 100644
--- a/src/main/java/net/minecraft/core/item/ItemJar.java
+++ b/src/main/java/net/minecraft/core/item/JarItem.java
@@ -1,27 +1,25 @@
 package net.minecraft.core.item;
 
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFluid;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.animal.EntityFireflyCluster;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.entity.animal.FireflyClusterMob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
 import java.util.List;
 
-import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
+public class JarItem extends PlaceableItem {
 
-public class ItemJar extends ItemPlaceable{
 
-    protected ItemJar(String name, int id) {
-        super(name, id, Block.jarGlass);
+
+    protected JarItem(String name, String namespaceId, int id) {
+        super(name, namespaceId, id, Blocks.JAR_GLASS);
         setMaxStackSize(64);
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack stack, EntityPlayer player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onUseItemOnBlock(ItemStack stack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if (player.isSneaking()) {
             return super.onUseItemOnBlock(stack, player, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
         }
@@ -34,30 +32,30 @@ public class ItemJar extends ItemPlaceable{
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
         if (entityplayer.isSneaking()) {
             return itemstack;
         }
-        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(entityplayer,entityplayer.bb.expand(2, 2, 2));
-        
+        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(entityplayer,entityplayer.bb.grow(2, 2, 2));
+
         for(Entity entity : list){
-            if(entity instanceof EntityFireflyCluster) {
-                EntityFireflyCluster fireflyCluster = (EntityFireflyCluster) entity;
-                EntityFireflyCluster.FireflyColor colour = fireflyCluster.getColor();
+            if(entity instanceof FireflyClusterMob) {
+                FireflyClusterMob fireflyCluster = (FireflyClusterMob) entity;
+                FireflyClusterMob.FireflyColor colour = fireflyCluster.getColor();
 
                 boolean didFillJar;
-                if(colour == EntityFireflyCluster.FireflyColor.BLUE){
-                    didFillJar = fillJar(entityplayer, new ItemStack(Item.lanternFireflyBlue, 1));
+                if(colour == FireflyClusterMob.FireflyColor.BLUE){
+                    didFillJar = fillJar(entityplayer, new ItemStack(Items.LANTERN_FIREFLY_BLUE, 1));
                 }
-                else if(colour == EntityFireflyCluster.FireflyColor.ORANGE){
-                    didFillJar = fillJar(entityplayer, new ItemStack(Item.lanternFireflyOrange, 1));
+                else if(colour == FireflyClusterMob.FireflyColor.ORANGE){
+                    didFillJar = fillJar(entityplayer, new ItemStack(Items.LANTERN_FIREFLY_ORANGE, 1));
                 }
-                else if(colour == EntityFireflyCluster.FireflyColor.RED){
-                    didFillJar = fillJar(entityplayer, new ItemStack(Item.lanternFireflyRed, 1));
+                else if(colour == FireflyClusterMob.FireflyColor.RED){
+                    didFillJar = fillJar(entityplayer, new ItemStack(Items.LANTERN_FIREFLY_RED, 1));
                 }
                 else{
-                    didFillJar = fillJar(entityplayer, new ItemStack(Item.lanternFireflyGreen, 1));
+                    didFillJar = fillJar(entityplayer, new ItemStack(Items.LANTERN_FIREFLY_GREEN, 1));
                 }
 
                 if(!world.isClientSide && didFillJar) {
@@ -74,9 +72,9 @@ public class ItemJar extends ItemPlaceable{
     }
 
 
-    public static boolean fillJar(EntityPlayer player, ItemStack itemToGive){
+    public static boolean fillJar(Player player, ItemStack itemToGive){
         if(player.inventory.getCurrentItem().stackSize <= 1) {
-            player.inventory.setInventorySlotContents(player.inventory.currentItem, itemToGive);
+            player.inventory.setItem(player.inventory.currentItem, itemToGive);
         } else {
         	player.inventory.insertItem(itemToGive, true);
         }
diff --git a/src/main/java/net/minecraft/core/item/ItemLabel.java b/src/main/java/net/minecraft/core/item/LabelItem.java
similarity index 70%
rename from src/main/java/net/minecraft/core/item/ItemLabel.java
rename to src/main/java/net/minecraft/core/item/LabelItem.java
index d0f953fe8..dbcdd36e5 100644
--- a/src/main/java/net/minecraft/core/item/ItemLabel.java
+++ b/src/main/java/net/minecraft/core/item/LabelItem.java
@@ -1,17 +1,17 @@
 package net.minecraft.core.item;
 
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.World;
 
-public class ItemLabel extends Item
+public class LabelItem extends Item
 {
-    protected ItemLabel(String name, int id) {
-        super(name, id);
+    protected LabelItem(String name, String namespaceId, int id) {
+        super(name, namespaceId, id);
         setMaxStackSize(1);
     }
 
 	@Override
-	public ItemStack onUseItem(final ItemStack stack, final World world, final EntityPlayer player) {
+	public ItemStack onUseItem(final ItemStack stack, final World world, final Player player) {
 		if(stack.hasCustomName()) {
 			return stack;
 		}
diff --git a/src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java b/src/main/java/net/minecraft/core/item/LoadedHandCannonItem.java
similarity index 50%
rename from src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java
rename to src/main/java/net/minecraft/core/item/LoadedHandCannonItem.java
index 6822ceb7c..8a636b15c 100644
--- a/src/main/java/net/minecraft/core/item/ItemHandCannonLoaded.java
+++ b/src/main/java/net/minecraft/core/item/LoadedHandCannonItem.java
@@ -1,36 +1,36 @@
 package net.minecraft.core.item;
 
 // Referenced classes of package net.minecraft.src:
-//            Item, EntityPlayer, InventoryPlayer, World,
-//            EntityArrow, ItemStack
+//            Item, Player, InventoryPlayer, World,
+//            ArrowProjectile, ItemStack
 
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.entity.projectile.EntityCannonball;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.projectile.CannonballProjectile;
 import net.minecraft.core.world.World;
 
-public class ItemHandCannonLoaded extends Item
+public class LoadedHandCannonItem extends Item
 {
 
-    public ItemHandCannonLoaded(String name, int id)
+    public LoadedHandCannonItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         setMaxDamage(100);
         maxStackSize = 1;
     }
 
 	@Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
 		world.playSoundAtEntity(entityplayer, entityplayer, "random.bow", 0.3F, 1.0F / (itemRand.nextFloat() * -0.2F + -0.4F));
 
 		if(!world.isClientSide)
 		{
 			itemstack.damageItem(1, entityplayer);
-			world.entityJoinedWorld(new EntityCannonball(world, entityplayer));
+			world.entityJoinedWorld(new CannonballProjectile(world, entityplayer));
 			if(itemstack.stackSize <= 0) {
 				return null;
 			}
-			return new ItemStack(Item.handcannonUnloaded, 1, itemstack.getMetadata(), itemstack.getData());
+			return new ItemStack(Items.HANDCANNON_UNLOADED, 1, itemstack.getMetadata(), itemstack.getData());
 		}
         return itemstack;
     }
diff --git a/src/main/java/net/minecraft/core/item/MapItem.java b/src/main/java/net/minecraft/core/item/MapItem.java
new file mode 100644
index 000000000..ceff4dace
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/MapItem.java
@@ -0,0 +1,398 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+
+// Referenced classes of package net.minecraft.src:
+//            ItemMapBase, MapData, World, ItemStack, 
+//            WorldInfo, WorldProvider, Entity, MathHelper, 
+//            Block, Chunk, Material, MapColor, 
+//            EntityPlayer
+
+import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.packet.MapDataPacket;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.block.material.MaterialColor;
+import net.minecraft.core.world.saveddata.maps.ItemMapSavedData;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.HashMap;
+import java.util.Map;
+
+
+public class MapItem extends Item implements IComplexItem
+{
+	private static final Map<Integer, Map<Integer, Integer>> blockCounts = new HashMap<>();
+    protected MapItem(String name, String namespaceId, int id)
+    {
+        super(name, namespaceId, id);
+    }
+
+    public static ItemMapSavedData getOrCreateSavedData(short meta, byte scale, World world)
+    {
+		String s = String.format("map_%s_scale_%s", meta, scale);
+        ItemMapSavedData mapData = (ItemMapSavedData)world.getSavedData(ItemMapSavedData.class, s);
+        if(mapData == null)
+        {
+			if (scale == 3){
+				mapData = (ItemMapSavedData)world.getSavedData(ItemMapSavedData.class, String.format("map_%s", meta));
+				if (mapData != null) {
+					for (byte i = 0; i <= ItemMapSavedData.MAX_SCALE; i++) {
+						String _s = String.format("map_%s_scale_%s", meta, i);
+						if (i == 3) {
+							world.setSavedData(_s, mapData);
+							continue;
+						}
+						ItemMapSavedData d = new ItemMapSavedData(_s);
+						d.x = mapData.x;
+						d.z = mapData.z;
+						d.scale = i;
+						d.dimension = mapData.dimension;
+						d.setDirty();
+						world.setSavedData(_s, d);
+					}
+					return mapData;
+				}
+			}
+            mapData = new ItemMapSavedData(s);
+			mapData.x = world.getLevelData().getSpawnX();
+			mapData.z = world.getLevelData().getSpawnZ();
+			mapData.scale = scale;
+			mapData.dimension = (byte)world.dimension.id;
+			mapData.setDirty();
+            world.setSavedData(s, mapData);
+        }
+        return mapData;
+    }
+
+	public static boolean hasInitialized(ItemStack stack){
+		return stack.getData().getBooleanOrDefault("initialized", false);
+	}
+	@Nullable
+    public ItemMapSavedData getOrCreateSavedData(ItemStack stack, World world)
+    {
+		if (!hasInitialized(stack)) return null;
+		byte scale = getScale(stack);
+		int meta = stack.getMetadata();
+        String s = String.format("map_%s_scale_%s", meta, scale);
+        ItemMapSavedData mapData = (ItemMapSavedData)world.getSavedData(ItemMapSavedData.class, s);
+        if(mapData == null)
+        {
+			if (scale == 3){
+				mapData = (ItemMapSavedData)world.getSavedData(ItemMapSavedData.class, String.format("map_%s", meta));
+				if (mapData != null) {
+					for (byte i = 0; i <= ItemMapSavedData.MAX_SCALE; i++) {
+						String _s = String.format("map_%s_scale_%s", meta, i);
+						if (i == 3) {
+							world.setSavedData(_s, mapData);
+							continue;
+						}
+						ItemMapSavedData d = new ItemMapSavedData(_s);
+						d.x = mapData.x;
+						d.z = mapData.z;
+						d.scale = i;
+						d.dimension = mapData.dimension;
+						d.setDirty();
+						world.setSavedData(_s, d);
+					}
+					return mapData;
+				}
+			}
+            mapData = new ItemMapSavedData(s);
+            mapData.x = world.getLevelData().getSpawnX();
+            mapData.z = world.getLevelData().getSpawnZ();
+            mapData.scale = scale;
+            mapData.dimension = (byte)world.dimension.id;
+            mapData.setDirty();
+            world.setSavedData(s, mapData);
+        }
+        return mapData;
+    }
+	@Override
+	public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+	{
+		if (!hasInitialized(itemstack)){
+			initMap(itemstack, world, entityplayer);
+		} else {
+			setScale(itemstack, (byte) (getScale(itemstack) + (entityplayer.isSneaking() ? 1 : -1)));
+		}
+		return itemstack;
+	}
+	@Override
+	public boolean onUseItemOnBlock(ItemStack itemstack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+		if (world.getBlockId(blockX, blockY, blockZ) == Blocks.FLAG.id) {
+			ItemMapSavedData mapData = getOrCreateSavedData(itemstack, world);
+			if (mapData != null){
+				FlagBlockEntity flag = (FlagBlockEntity) world.getBlockEntity(blockX, blockY, blockZ);
+				boolean canCreateMap = mapData.createNewWaypoint(flag);
+				if(!canCreateMap)
+					player.sendTranslatedChatMessage("flag.full");
+				return canCreateMap;
+			}
+		}
+		return false;
+	}
+
+	public void update(World world, Entity entity, ItemMapSavedData data) {
+		if(world.dimension.id != data.dimension) {
+			return;
+		}
+		
+		final int mapWidth = 128;
+		final int mapHeight = 128;
+		final int blocksPerPixel = 1 << data.scale;
+		final int mapCenterX = data.x;
+		final int mapCenterZ = data.z;
+
+		final int entityOnMapX = MathHelper.floor(entity.x - (double) mapCenterX) / blocksPerPixel + mapWidth / 2;
+		final int entityOnMapZ = MathHelper.floor(entity.z - (double) mapCenterZ) / blocksPerPixel + mapHeight / 2;
+
+		int discoverRadius = 128 / blocksPerPixel;
+		if(world.worldType.hasCeiling()) {
+			discoverRadius /= 2;
+		}
+		
+		data.step++;
+		
+		for (int x = (entityOnMapX - discoverRadius) + 1; x < entityOnMapX + discoverRadius; x++) {
+			if((x & 0xf) != (data.step & 0xf)) {
+				continue;
+			}
+			int minZ = 255;
+			int maxZ = 0;
+			double previousPixelHeight = 0.0;
+			
+			// Pixel brightness changes depending on the height of the above pixel
+			// Make sure we know the height of the above pixel when drawing this one,
+			// Otherwise there will be lines on borders from loaded to unloaded chunks
+			boolean previousChunkLoaded = false;
+			
+			for (int z = entityOnMapZ - discoverRadius - 1; z < entityOnMapZ + discoverRadius; z++) {
+				if(x < 0 || z < -1 || x >= mapWidth || z >= mapHeight) {
+					continue;
+				}
+				int distX = x - entityOnMapX;
+				int distZ = z - entityOnMapZ;
+				boolean flag = distX * distX + distZ * distZ > (discoverRadius - 2) * (discoverRadius - 2);
+				
+				int blockX = ((mapCenterX / blocksPerPixel + x) - mapWidth / 2) * blocksPerPixel;
+				int blockZ = ((mapCenterZ / blocksPerPixel + z) - mapHeight / 2) * blocksPerPixel;
+				
+				// Make sure to only draw loaded chunks, otherwise the map disappears around the player when the server view distance is low
+				if(!world.isBlockLoaded(blockX, world.getHeightBlocks() / 2, blockZ)) {
+					previousChunkLoaded = false;
+					continue;
+				}
+
+				blockCounts.clear();
+				Chunk chunk = world.getChunkFromBlockCoords(blockX, blockZ);
+				
+				
+				int blockInChunkX = blockX & 0xf;
+				int blockInChunkZ = blockZ & 0xf;
+				
+				int waterDepth = 0;
+				double pixelHeight = 0.0D;
+				
+				if(world.worldType.hasCeiling()) {
+					//Determine Color (Nether)
+					int rand = blockX + blockZ * 0x389bf;
+					rand = rand * rand * 0x1dd6751 + rand * 11;
+					if((rand >> 20 & 1) == 0) {
+						blockCounts.putIfAbsent(Blocks.DIRT.id, new HashMap<>());
+						blockCounts.get(Blocks.DIRT.id).put(-1, blockCounts.get(Blocks.DIRT.id).getOrDefault(-1, 0) + 10);
+					} else {
+						blockCounts.putIfAbsent(Blocks.STONE.id, new HashMap<>());
+						blockCounts.get(Blocks.STONE.id).put(-1, blockCounts.get(Blocks.STONE.id).getOrDefault(-1, 0) + 10);
+					}
+					pixelHeight = 100D;
+				} else {
+					//Determine Color (Not Nether)
+					for (int _x = 0; _x < blocksPerPixel; _x++) {
+						for (int _z = 0; _z < blocksPerPixel; _z++) {
+							int height = chunk.getHeightValue(_x + blockInChunkX, _z + blockInChunkZ);
+							int id = 0;
+                            if(height > 0) {
+								boolean runLoop;
+								do {
+									runLoop = false;
+									id = chunk.getBlockID(_x + blockInChunkX, height, _z + blockInChunkZ);
+									if(id <= 0 || (height > 0 && Block.blocksList[id].blockMaterial.color == MaterialColor.none)) {
+										runLoop = true;
+										height--;
+									}
+								} while (runLoop);
+								if(Block.blocksList[id].blockMaterial == Material.water) {
+									int _y = height;
+                                    int _blockID = chunk.getBlockID(_x + blockInChunkX, _y--, _z + blockInChunkZ);
+                                    waterDepth++;
+                                    while (_y > 0 && _blockID > 0 && Block.blocksList[_blockID].blockMaterial == Material.water) {
+                                        _blockID = chunk.getBlockID(_x + blockInChunkX, _y--, _z + blockInChunkZ);
+                                        waterDepth++;
+                                    }
+								}
+							}
+							pixelHeight += (double) height / (double) (blocksPerPixel * blocksPerPixel);
+                            int meta = chunk.getBlockMetadata(_x + blockInChunkX, height, _z + blockInChunkZ);
+							blockCounts.putIfAbsent(id, new HashMap<>());
+							blockCounts.get(id).put(-1, blockCounts.get(id).getOrDefault(-1, 0) + 1);
+							blockCounts.get(id).put(meta, blockCounts.get(id).getOrDefault(meta, 0) + 1);
+						}
+
+					}
+
+				}
+				waterDepth /= blocksPerPixel * blocksPerPixel;
+				
+				int max = 0;
+				int id = 0;
+				for (Map.Entry<Integer, Map<Integer, Integer>> e : blockCounts.entrySet()){
+					if (e.getValue().getOrDefault(-1, -1) > max){
+						id = e.getKey();
+						max = e.getValue().get(-1);
+					}
+				}
+
+				int meta = 0;
+				max = 0;
+				for (int i = 0; i < 256; i++) {
+					if (blockCounts.get(id).getOrDefault(i, -1) > max){
+						meta = i;
+						max = blockCounts.get(id).get(i);
+					}
+				}
+
+				double heightDifference = ((pixelHeight - previousPixelHeight) * 4D) / (double) (blocksPerPixel + 4) + ((double) (x + z & 1) - 0.5D) * 0.4D;
+				byte brightness = 1;
+				if(heightDifference > 0.6D) brightness = 2;
+				if(heightDifference < -0.6D) brightness = 0;
+				
+				int colorIndex = 0;
+				if(id > 0) {
+					MaterialColor mapcolor = Block.blocksList[id].blockMaterial.color;
+					if(mapcolor == MaterialColor.water) {
+						double d3 = (double) waterDepth * 0.1D + (double) (x + z & 1) * 0.2D;
+						brightness = 1;
+						if(d3 < 0.5D) {
+							brightness = 2;
+						}
+						if(d3 > 0.9D) {
+							brightness = 0;
+						}
+					}
+					colorIndex = MaterialColor.getColorIndexFromBlock(Block.blocksList[id], meta);
+				}
+				previousPixelHeight = pixelHeight;
+				if(!previousChunkLoaded) {
+					previousChunkLoaded = true;
+					continue;
+				}
+				if(z < 0 || distX * distX + distZ * distZ >= discoverRadius * discoverRadius || flag && (x + z & 1) == 0) {
+					continue;
+				}
+				byte currentColor = data.colors[x + z * mapWidth];
+				byte finalColor = (byte) (colorIndex << 2 | brightness & 0b11);
+				if(currentColor == finalColor) {
+					continue;
+				}
+				
+				if(minZ > z) minZ = z;
+				if(maxZ < z) maxZ = z;
+				data.colors[x + z * mapWidth] = finalColor;
+			}
+
+			if(minZ <= maxZ) {
+				data.setDirty(x, minZ, maxZ);
+			}
+		}
+
+	}
+
+    @Override
+    public void inventoryTick(ItemStack itemstack, World world, Entity entity, int i, boolean flag)
+    {
+        if(world.isClientSide)
+        {
+            return;
+        }
+        ItemMapSavedData mapData = getOrCreateSavedData(itemstack, world);
+        if (mapData != null){
+			if(entity instanceof Player)
+			{
+				Player player = (Player)entity;
+				mapData.tickCarriedBy(player, itemstack);
+			}
+			if(flag)
+			{
+				update(world, entity, mapData);
+			}
+		}
+    }
+
+
+    public void initMap(ItemStack itemstack, World world, Player player)
+    {
+		boolean insert = itemstack.stackSize > 1;
+		if (insert){
+			itemstack.stackSize -= 1;
+			itemstack = itemstack.copy();
+			itemstack.stackSize = 1;
+		}
+        itemstack.setMetadata(world.getUniqueDataId("map"));
+		for (byte i = 0; i <= ItemMapSavedData.MAX_SCALE; i++) {
+			String s = "map_" + itemstack.getMetadata() + "_scale_" + i;
+			ItemMapSavedData mapdata = new ItemMapSavedData(s);
+			world.setSavedData(s, mapdata);
+			mapdata.x = (MathHelper.floor(player.x) >> 4) << 4;
+			mapdata.z = (MathHelper.floor(player.z) >> 4) << 4;
+			mapdata.scale = i;
+			mapdata.dimension = (byte)world.dimension.id;
+			mapdata.setDirty();
+		}
+		itemstack.getData().putBoolean("initialized", true);
+		if (insert){
+			player.inventory.insertItem(itemstack, true);
+		}
+    }
+
+    @Override
+	public Packet sendPacketData(ItemStack itemstack, World world, Player player)
+    {
+		ItemMapSavedData itemMapSavedData = getOrCreateSavedData(itemstack, world);
+        if (itemMapSavedData != null){
+			byte[] mapDataBytes = itemMapSavedData.getMapDataBytes(itemstack, world, player);
+			if(mapDataBytes == null)
+			{
+				return null;
+			} else
+			{
+				return new MapDataPacket((short)Items.MAP.id, (short)itemstack.getMetadata(), getScale(itemstack), mapDataBytes, itemMapSavedData.mapWaypoints);
+			}
+		}
+		return null;
+    }
+    
+    @Override
+    public String getTranslatedName(ItemStack itemstack) {
+		if (!hasInitialized(itemstack)) return I18n.getInstance().translateKey(itemstack.getItemKey() + ".blank.name");
+    	return super.getTranslatedName(itemstack) + " #" + itemstack.getMetadata();
+    }
+	private byte getScale(ItemStack itemStack){
+		return itemStack.getData().getByteOrDefault("scale", (byte) 3);
+	}
+	private void setScale(ItemStack itemStack, byte scale){
+		byte currentScale = getScale(itemStack);
+		while (scale < 0) scale += 5;
+		if (currentScale == scale) return;
+		scale %= 5;
+		itemStack.getData().putByte("scale", scale);
+	}
+}
diff --git a/src/main/java/net/minecraft/core/item/MinecartItem.java b/src/main/java/net/minecraft/core/item/MinecartItem.java
new file mode 100644
index 000000000..0735d2dd6
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/MinecartItem.java
@@ -0,0 +1,33 @@
+package net.minecraft.core.item;
+
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.RailBlock;
+
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.vehicle.MinecartEntity;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+public class MinecartItem extends Item {
+    public final int minecartType;
+    public MinecartItem(String name, String namespaceId, int id, int type) {
+        super(name, namespaceId, id);
+        setMaxStackSize(1);
+        minecartType = type;
+    }
+
+    @Override
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+        Block block = world.getBlock(blockX, blockY, blockZ);
+        if (!(block instanceof RailBlock)) { return false; }
+
+        if(!world.isClientSide) {
+            world.entityJoinedWorld(new MinecartEntity(world, (float) blockX + 0.5F, (float) blockY + 0.5F, (float) blockZ + 0.5F, minecartType));
+        }
+        if (entityplayer.getGamemode().consumeBlocks()) {
+            itemstack.stackSize--;
+        }
+        return true;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/item/MusicDiscItem.java b/src/main/java/net/minecraft/core/item/MusicDiscItem.java
new file mode 100644
index 000000000..3b7f2cff8
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/MusicDiscItem.java
@@ -0,0 +1,44 @@
+package net.minecraft.core.item;
+
+
+// Referenced classes of package net.minecraft.src:
+//            Item, World, Block, JukeboxBlock,
+//            ItemStack, Player
+
+import net.minecraft.core.block.JukeboxBlock;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+
+public class MusicDiscItem extends Item
+{
+    public final String recordName;
+    public final String recordAuthor;
+
+
+    public MusicDiscItem(String name, String namespaceId, int id, String recordName, String recordAuthor)
+    {
+        super(name, namespaceId, id);
+        this.recordName = recordName;
+        this.recordAuthor = recordAuthor;
+        maxStackSize = 1;
+    }
+
+    @Override
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    {
+        if(world.getBlockId(blockX, blockY, blockZ) == Blocks.JUKEBOX.id && world.getBlockMetadata(blockX, blockY, blockZ) == 0)
+        {
+            if (!world.isClientSide) {
+                ((JukeboxBlock) Blocks.JUKEBOX).playRecord(world, blockX, blockY, blockZ, id);
+                world.playSoundEffect(null, 1005, blockX, blockY, blockZ, id);
+                itemstack.consumeItem(entityplayer);
+            }
+            return true;
+        } else
+        {
+            return false;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/item/ItemDoorPainted.java b/src/main/java/net/minecraft/core/item/PaintedDoorItem.java
similarity index 82%
rename from src/main/java/net/minecraft/core/item/ItemDoorPainted.java
rename to src/main/java/net/minecraft/core/item/PaintedDoorItem.java
index c283b0002..3219b1b5a 100644
--- a/src/main/java/net/minecraft/core/item/ItemDoorPainted.java
+++ b/src/main/java/net/minecraft/core/item/PaintedDoorItem.java
@@ -1,19 +1,19 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockWool;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class ItemDoorPainted extends ItemDoor{
-    public ItemDoorPainted(String name, int id, Block doorBottom, Block doorTopId) {
-        super(name, id, doorBottom, doorTopId);
+public class PaintedDoorItem extends DoorItem {
+    public PaintedDoorItem(String name, String namespaceId, int id, Block doorBottom, Block doorTopId) {
+        super(name, namespaceId, id, doorBottom, doorTopId);
     }
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(!world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
             blockX += side.getOffsetX();
             blockY += side.getOffsetY();
@@ -60,6 +60,6 @@ public class ItemDoorPainted extends ItemDoor{
     @Override
     public String getLanguageKey(ItemStack itemstack)
     {
-        return (new StringBuilder()).append(super.getKey()).append(".").append(ItemDye.dyeColors[itemstack.getMetadata() & 0xF]).toString();
+        return super.getKey() + "." + DyeColor.colorFromItemMeta(itemstack.getMetadata()).colorID;
     }
 }
diff --git a/src/main/java/net/minecraft/core/item/ItemPainting.java b/src/main/java/net/minecraft/core/item/PaintingItem.java
similarity index 63%
rename from src/main/java/net/minecraft/core/item/ItemPainting.java
rename to src/main/java/net/minecraft/core/item/PaintingItem.java
index 1ee4e066b..d5bf9bcdc 100644
--- a/src/main/java/net/minecraft/core/item/ItemPainting.java
+++ b/src/main/java/net/minecraft/core/item/PaintingItem.java
@@ -2,26 +2,26 @@ package net.minecraft.core.item;
 
 
 // Referenced classes of package net.minecraft.src:
-//            Item, EntityPainting, World, ItemStack, 
-//            EntityPlayer
+//            Item, PaintingEntity, World, ItemStack,
+//            Player
 
-import net.minecraft.core.entity.EntityPainting;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.PaintingEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class ItemPainting extends Item
+public class PaintingItem extends Item
 {
 
-    public ItemPainting(String name, int id)
+    public PaintingItem(String name, String namespaceId, int id)
     {
-        super(name, id);
+        super(name, namespaceId, id);
     }
 
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
         if (!world.isClientSide && !entityplayer.isSneaking())
         {
@@ -32,7 +32,7 @@ public class ItemPainting extends Item
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
     	int sideHit = side.getId();
         if(sideHit == 0)
@@ -56,14 +56,14 @@ public class ItemPainting extends Item
         {
             direction = 3;
         }
-        EntityPainting entity = new EntityPainting(world, blockX, blockY, blockZ, direction, entityplayer.getSelectedArt().key);
-        if(entity.canFitPainting())
+        PaintingEntity entity = new PaintingEntity(world, blockX, blockY, blockZ, direction, entityplayer.getSelectedArt().key);
+        if(entity.canStay())
         {
             if(!world.isClientSide)
             {
                 world.entityJoinedWorld(entity);
             }
-            world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.planksOak, EnumBlockSoundEffectType.PLACE);
+            world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
             itemstack.consumeItem(entityplayer);
         }
         return true;
